:- module(verifier, [verify_rules/1]).

% This module verifies all the generated rules.
:- use_module(symtab,   [get_real_rules/2] ).
:- use_module(curryast, [check_tree/1] ).

%% Verify rules, 
%% Fixme, change to map_rules.
verify_rules(Module) :-
	get_real_rules(Name, Rules),
	verify_rules_list(Name, Rules),
	fail.
verify_rules.

%% List version of v_r.
verify_rules_list(_Name, []).
verify_rules_list(Name,  [R|Rs]) :-
	( 
	    check_tree(R) ->
%%%         display('\nRule verification OK ['),
% 	    write(Name),
% 	    write('] : '),
% 	    write(R),
	    verify_rules_list(Name, Rs)
	;
	    %% FIXME: throw rule_verification exception.,
	    display('\nRule verification error ['),
	    write(Name),
	    write('] : '),
	    write(R),
	    verify_rules_list(Name, Rs)
	).


%% Local Variables: 
%% mode: CIAO
%% update-version-comments: "off"
%% End:

