module Queensf where

import IO

add_queen q lists = map ([q] ++) lists

range n m = if (n==m) then [n] else (n:range (n+1) m)

attack x n (y:ys) = x==y+n || x==y-n || attack x (n+1) ys || x==y
attack x n [] = False

safe (x:xs) = not (attack x 1 xs)

new_boards [] _ = []
new_boards (r:rs) boards = 
  (filter safe (add_queen r boards)) ++ (new_boards rs boards)

queens_aux n acum poss =
  if (n==0) then acum
  else queens_aux (n - 1) (new_boards poss acum) poss 

queens n = queens_aux n [[]] (range 1 n)

main = printLn $ queens 5


