module Uncurry where

import IO

-- Example from Julio's thesis.
-- Uncurried trees.
data Gtree a = Node a [Gtree a] 

-- Curried trees.
data Btree a = Leaf a 
             | Nd (Btree a) (Btree a)
             | Empty 

apply          :: Btree a -> [Btree a] -> Btree a
apply f []     = f
apply f (x:xs) = apply (Nd f x) xs

-- 
tcurry :: Gtree a -> Btree a
tcurry (Node root sons) = 
    apply (Leaf root) (map tcurry sons)

-- 
tuncurry :: Btree a -> Gtree a
tuncurry t = let x free in t =:= tcurry x &> x

t1 :: Gtree Int
t1 = Node 1 [(Node 2 []), (Node 3 [(Node 4 [])])]

main = printLn $ tuncurry (tcurry t1)
